include \masm32\include\masm32rt.inc
	include \masm32\include\winmm.inc
	includelib \masm32\Lib\winmm.lib
	sync = 1	; [url=http://www.masm32.com/board/index.php?topic=13478.msg105421#msg105421]MichaelW[/url]: Synchronizing with the tick count at the start of the timed period will cut the uncertainty in half

Timer MACRO arg
  push ecx	; save some regs
  push edx
;  invoke GetTickCount
  invoke timeGetTime
  ifidni <arg>, <start>
	.if 1
		if sync
		push eax
		.Repeat
;			invoke GetTickCount
      invoke timeGetTime
			inc gtcloops
		.Until eax!=[esp]
		pop edx		; don't trash eax
		endif
		pop edx
		pop ecx
		push eax
		EXITM <>		;; return an empty string for Timer(start)
  else
		pop edx
		pop ecx
		pop edx			;; get the value of Timer(start)
		sub eax, edx	;; return elapsed milliseconds
	.endif
	EXITM <eax>
  endif
ENDM

.data?
globdiff	dd ?
gtcloops	dd ?
hEvent    dd ?

.code
start:
  invoke GetCurrentProcess
  invoke SetProcessAffinityMask,eax,1
  invoke GetCurrentProcess
  invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
	invoke timeBeginPeriod,1
	invoke Sleep, 100
	invoke CreateEvent,NULL, TRUE, FALSE,NULL
	mov hEvent,eax
	
	mov ebx, 20
	.Repeat
		imul esi, ebx, 10		; esi=ebx*10
		Timer(start)
;		mov ecx,esi
;		.repeat
;		  push ecx
;		  invoke Sleep,1
;		  pop ecx
;		  dec ecx
;		.until ecx == 0 
		
		invoke Sleep, esi
		mov edi, Timer(end)
		print str$(edi), 9, " expected: "
		print str$(esi), ", abs(diff)="
		sub edi, esi
		.if Sign?
			neg edi
		.endif
		add globdiff, edi
		print str$(edi), 13, 10
		dec ebx
	.Until Zero?
	print "Overall difference: "
	print str$(globdiff), 13, 10, "wait loops: "
	print str$(gtcloops)
	invoke timeEndPeriod,1	
	getkey
	exit

end start

OPT_Assembler	JWAsm
OPT_Wait	0
OPT_Tmp2Asm	1
